//(c) Loe Feijs and TU/e 2014-2016
//Dragon curve using turtle graphics

import processing.pdf.*;
import nl.tue.id.oogway.*;

int XSIZE=int(3.6*297);
int YSIZE=int(3.6*210);

PFont font16, font32;
PGraphicsPDF pdf;

void setup() {
     noLoop();
     size(XSIZE,YSIZE);
     pdf = (PGraphicsPDF) beginRecord(PDF, "DRAGON_FLOAT.pdf");
}


   
//from rosettacode.org/wiki/Dragon_curve in logo:
//to dcr :step :length
//  make "step :step - 1
//  make "length :length / 1.41421
//  if :step > 0 [rt 45 dcr :step :length lt 90 dcl :step :length rt 45]
//  if :step = 0 [rt 45 fd :length lt 90 fd :length rt 45]
//end
 
//to dcl :step :length
//  make "step :step - 1
//  make "length :length / 1.41421
//  if :step > 0 [lt 45 dcr :step :length rt 90 dcl :step :length lt 45]
//  if :step = 0 [lt 45 fd :length rt 90 fd :length lt 45]
//end
//The program can be started using dcr 4 300 or dcl 4 300.

void dcr(Oogway o, int step, float len){
     int newstep = step - 1;
     float newlen = len / 1.41421;
     if (step > 0){
        o.right(45);
        dcr(o,newstep, newlen);
        o.left(90);
        dcl(o,newstep, newlen);
        o.right(45);
     }
     if (step == 0){
        o.right(45);
        o.forward(newlen);
        o.left(90);
        o.forward(newlen);
        o.right(45);
     }
}

void dcl(Oogway o, int step, float len){
     int newstep = step - 1;
     float newlen = len / 1.41421;
     if (step > 0){
        o.left(45);
        dcr(o,newstep, newlen);
        o.right(90);
        dcl(o,newstep, newlen);
        o.left(45);
     }
     if (step == 0){
        o.left(45);
        o.forward(newlen);
        o.right(90);
        o.forward(newlen);
        o.left(45);
     }
}


void draw() {
     fill(0);
     stroke(0);
     background(255);
     pdf.textMode(SHAPE);
     Oogway o = new Oogway(this);
     o.setPosition(400,300);
     o.setPenSize(.5);
     o.setHeading(0);
     
     font16 = createFont("Comic Sans MS",16); 
     font32 = createFont("Comic Sans MS",16); 
     drwIntro();
     o.setPenColor(0, 0, 0);
     float dim = 200.0;

     dcr(o, 14, 500);

    
     endRecord();
}

void drwIntro(){
     textFont(font32,32);
     text("Fractals and Turtles",200,50);
     textFont(font16,16);
     text("Dragon Curve"
         , 200, 75,700,200); 
}

void stop(){
     endRecord();
}

